/**
 * Canvas API & requestAnimationFrame Example
 * @ Arindam Chattopadhya
 */
var requestID; 	//store the requestAnimationFrame requestID value

function init()
{
	drawGraph();
	drawLine();
	drawCurves();
	animate();
}

function drawGraph()
{
	var canvas = document.getElementById('GraphCanvas');
    var context = canvas.getContext('2d');
	for (var x = 0.5; x < 500; x += 10) {
		  context.moveTo(x, 0);
		  context.lineTo(x, 375);
		}
	for (var y = 0.5; y < 375; y += 10) {
		  context.moveTo(0, y);
		  context.lineTo(500, y);
		}
	context.strokeStyle = "#0B1907";
	context.stroke();
	
		   	
}

function drawLine(){
	 var canvas = document.getElementById('LineCanvas');
     var context = canvas.getContext('2d');

     // butt line cap (top line)
     context.beginPath();
     context.moveTo(200, canvas.height / 2 - 50);
     context.lineTo(canvas.width - 200, canvas.height / 2 - 50);
     context.lineWidth = 20;
     context.strokeStyle = '#DF013A';
     context.lineCap = 'butt';
     context.stroke();

     // round line cap (middle line)
     context.beginPath();
     context.moveTo(200, canvas.height / 2);
     context.lineTo(canvas.width - 200, canvas.height / 2);
     context.lineWidth = 20;
     context.strokeStyle = '#DF013A';
     context.lineCap = 'round';
     context.stroke();

     // square line cap (bottom line)
     context.beginPath();
     context.moveTo(200, canvas.height / 2 + 50);
     context.lineTo(canvas.width - 200, canvas.height / 2 + 50);
     context.lineWidth = 20;
     context.strokeStyle = '#DF013A';
     context.lineCap = 'square';
     context.stroke();
	
}
 function drawCurves(){
	 var canvas = document.getElementById('CurvesCanvas');
     var context = canvas.getContext('2d');
     //draw a circle
     var x = canvas.width /2;
     var y = canvas.height /2;
     var radius = 25;
     var startAngle = 0;
     var endAngle = 2 * Math.PI;
     var counterClockwise = false;
     context.beginPath();
     context.arc(x, y, radius, startAngle, endAngle, counterClockwise);
     context.lineWidth = 5;
     context.strokeStyle = 'black';
     context.stroke();
     // draw quadraticCurve
     context.beginPath();
     context.moveTo(140, 120);//create context point
     context.quadraticCurveTo(288, 0, 388, 150);
     context.lineWidth = 8;
     context.strokeStyle = 'brown';
     
     context.stroke();
     //draw bezierCurve
     context.beginPath();
     context.moveTo(200, 250);//create context point
     context.bezierCurveTo(150, 15, 388, 10, 388, 170);
     context.lineWidth = 8;
     context.strokeStyle = 'green';
     context.stroke();
     
 }
 // Animation creation
 
function animate(){
	var requestAnimationFrame= window.requestAnimationFrame||
	   						   window.webkitRequestAnimationFrame||
	   						   window.mozRequestAnimationFrame||
	   						   window.msRequestAnimationFrame ;
	//get a valid cancelAnimationFrame function as per the vendor
	
	
	
	//returns the first element that matches a specified CSS selector(s) in the document
	var symbols = document.querySelector("#symbol");
	//vendor specific check
	
	var displayCHARS = "abcdefghijklmnopqrstvwxyz1234567890".split("");
	var l = displayCHARS[Math.floor(Math.random()*displayCHARS.length)];
	symbols.textContent = l;
	
	//using setTimeout to delay when the next requestAnimationFrame call gets made.Typically the frame rate is 60 frames per second(FPS)
	//setTimeout(function(){
		//requestAnimationFrame(animate);	
	//},1000/10);
	//if you want to call it at normal FPS
	//requestAnimationFrame(animate);
}

/* Uncomment the following to stop animation 
function StopAnimation(){
	var cancelRAF = window.cancelAnimationFrame||
		window.webkitCancelAnimationFrame||
		window.mozCancelAnimationFrame||
		window.msCancelAnimationFrame ;
	cancelRAF(requestID);
}	
*/
